//here should be the new versions of functions we get called with our hooks

#include "plugin.h"

#define CLIENT_COMMAND_DEFINITIONS
#include "complexmacros.h"
#undef CLIENT_COMMAND_DEFINITIONS
#include <sdk_util.h> //useful almost everywhere
#include <cbase.h>
#include <usercmd.h>
bool PlayerElect[1024];
float fLastSporeTime=0.0f;
float fResLastD = 0.0f;
float fResLastS = 0.0f;

int Spawn(edict_t *pEntity) {
	if(FStrEq(STRING(pEntity->v.classname), "worldspawn")) //worldspawn means that everything is just starting up
	{
		//this is the only place you can precache new things, so do it here
		fLastSporeTime=0.0;
		fResLastD = 0.0f;
		fResLastS = 0.0f;
		DynamicSizedData.Initialize();
		RETURN_META_VALUE(MRES_HANDLED, 0);
	}

	RETURN_META_VALUE(MRES_IGNORED, 0);
}


BOOL ClientConnect( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  ) {

	char message[255];
	sprintf(message,"* Mod: Gorges can +attack chambers to sporify them. \"sporify\" in console for details.\n");
	CLIENT_PRINTF(pEntity,print_console,message);
	RETURN_META_VALUE(MRES_HANDLED,true);
}

//you don't need to really understand this, basically it just uses my macros to 
//reroute client commands to the functions you declare in clientcommands.h
void ClientCommand( edict_t *pEntity )
{
	const char* szUserCommand = CMD_ARGV(0);
	if( szUserCommand[0] == '\0' ) return; //to get rid of warnings if the plugin doesn't make any client commands
	if (!strcmp(CMD_ARGV(0),"sporify"))
	{

		char message[255];
		sprintf(message,"Sporification details\n");
		CLIENT_PRINTF(pEntity,print_console,message);
		sprintf(message,"================================\n");
		CLIENT_PRINTF(pEntity,print_console,message);
		sprintf(message,"  * Time to upgrade: %2.2f\n",cvar_sd_rspore_time->value);
		CLIENT_PRINTF(pEntity,print_console,message);
		sprintf(message,"  * Damage from chamber spores: %2.2f\n",cvar_sd_rspore_dmg->value);
		CLIENT_PRINTF(pEntity,print_console,message);
		sprintf(message,"  * Chamber spores damage rof: %2.2f\n",cvar_sd_rspore_dtime->value);
		CLIENT_PRINTF(pEntity,print_console,message);
		sprintf(message,"  * Chamber spores radius: %2.2f\n",cvar_sd_rspore_range->value);
		CLIENT_PRINTF(pEntity,print_console,message);

		int iRsporeBuild = (int)cvar_sd_rspore_build->value;
		if (iRsporeBuild > 0)
		{
			CLIENT_PRINTF(pEntity,print_console,"  * The following chambers may be sporified:\n");
			//sprintf(message,"");
			if ((iRsporeBuild & 1) > 0)
			CLIENT_PRINTF(pEntity,print_console,"    - Alien resource towers\n");
			if ((iRsporeBuild & 2) > 0)
			CLIENT_PRINTF(pEntity,print_console,"    - Offense chambers\n");
			if ((iRsporeBuild & 4) > 0)
			CLIENT_PRINTF(pEntity,print_console,"    - Defense chambers\n");
			if ((iRsporeBuild & 8) > 0)
			CLIENT_PRINTF(pEntity,print_console,"    - Movement chambers\n");
			if ((iRsporeBuild & 16) > 0)
			CLIENT_PRINTF(pEntity,print_console,"    - Sensory chambers\n");

		}
		else
		{
			CLIENT_PRINTF(pEntity,print_console,"  * No chambers may be sporified\n");
		}
		if (cvar_sd_rspore_heavy->value  == 2)
			sprintf(message,"  * Heavy armors take half damage from the chamber spores.\n");
		else if (cvar_sd_rspore_heavy->value == 1)
			sprintf(message,"  * Heavy armors are immune from the chamber spores.\n");
		else
			sprintf(message,"  * Heavy armors take full damage from the chamber spores.\n");
		CLIENT_PRINTF(pEntity,print_console,message);
		CLIENT_PRINTF(pEntity,print_console,"To sporify a chamber, as gorge, walk up to it and look at it and hold down your attack key.  A progress bar will show you how far along your sporification process is.\n");
		RETURN_META(MRES_SUPERCEDE);
	}
	//these next 3 lines will use the super duper DEFINE_CLIENT_COMMAND() macro to route each command to the appropriate function
	#define REGISTERING_CLIENT_COMMANDS
		#include "complexmacros.h"
	#undef REGISTERING_CLIENT_COMMANDS
	
	RETURN_META(MRES_IGNORED);
}

void StartFrame(void)
{
	int updatespores=0;
	int iResHeavy=(int)cvar_sd_rspore_heavy->value;
	float fResDTime=cvar_sd_rspore_dtime->value;
	float fResSTime=cvar_sd_rspore_stime->value;
	float fResRange=cvar_sd_rspore_range->value;
	float fResDmg=cvar_sd_rspore_dmg->value;
	float fResOffset=cvar_sd_rspore_offset->value;
	// Check for spore damage/emissions

	if ((gpGlobals->time - fResLastD) >= fResDTime)
	{

		fResLastD = gpGlobals->time;
		int counter=0;
		CBaseEntity *pRes = NULL;
		CBaseEntity *pPlayer = NULL;
		for (counter=1;counter<=gpGlobals->maxClients;counter++)
		{
			int pplayerdamage=0;
			pPlayer = UTIL_PlayerByIndex(counter);
			if (pPlayer != NULL)
			{
				if (!((pPlayer->pev->iuser4 & 4194304) > 0)&&!(pPlayer->pev->deadflag > 0)) // Alive, and not being digested.
				{
					while ((pRes = UTIL_FindEntityByString(pRes,"classname","alienresourcetower")) != NULL)
					{
					if (pplayerdamage == 0)
							pplayerdamage = UTIL_DoSpore(pPlayer,pRes,iResHeavy,fResSTime,fResRange,fResDmg,fResOffset);
					}
					pRes = NULL;
					while ((pRes = UTIL_FindEntityByString(pRes,"classname","offensechamber")) != NULL)
					{
						if (pplayerdamage == 0)
							pplayerdamage = UTIL_DoSpore(pPlayer,pRes,iResHeavy,fResSTime,fResRange,fResDmg,fResOffset);
					}
					pRes = NULL;
					while ((pRes = UTIL_FindEntityByString(pRes,"classname","defensechamber")) != NULL)
					{
						if (pplayerdamage == 0)
							pplayerdamage = UTIL_DoSpore(pPlayer,pRes,iResHeavy,fResSTime,fResRange,fResDmg,fResOffset);
					}
					pRes = NULL;
					while ((pRes = UTIL_FindEntityByString(pRes,"classname","movementchamber")) != NULL)
					{
						if (pplayerdamage == 0)
							pplayerdamage = UTIL_DoSpore(pPlayer,pRes,iResHeavy,fResSTime,fResRange,fResDmg,fResOffset);
					}
					pRes = NULL;
					while ((pRes = UTIL_FindEntityByString(pRes,"classname","sensorychamber")) != NULL)
					{
						if (pplayerdamage == 0)
							pplayerdamage = UTIL_DoSpore(pPlayer,pRes,iResHeavy,fResSTime,fResRange,fResDmg,fResOffset);
					}
					pRes = NULL;
				}
			}
		}
	}
	// Sporification
	if(gpGlobals->time >= fLastSporeTime+(cvar_sd_rspore_time->value/10.0)/2.0)
	{

		CBaseEntity *pCPlayer = NULL;
		while(pCPlayer = UTIL_FindEntityByClassname(pCPlayer, "player"))
		{
			edict_t *pEntity;
			pEntity = pCPlayer->edict();

			// is it a gorge holding his USE key?
			if((FStrEq(STRING(pEntity->v.model),"models/player/alien2/alien2.mdl")) && (pEntity->v.team == 2) && (pEntity->v.deadflag == 0) && (pEntity->v.button & IN_ATTACK))
			{
				CBaseEntity *CForwardObject = NULL;
				CForwardObject = FindEntityForward( pCPlayer );
				// what we pointing at?
				if( CForwardObject != NULL )
				{
					edict_t *pFEntity = CForwardObject->edict();
					// can we sporeify this build entity we pointing at?
					if(UTIL_CanSporify(pFEntity) && UTIL_IsBuilt(pFEntity) && (CForwardObject->pev->vuser3.x == 0))
					{
						if (pFEntity->v.vuser3.x == 0 && pFEntity->v.fuser1 >= 1000)
						{
							pFEntity->v.fuser1 = 0;
						}
						if(PlayerElect[ENTINDEX(pEntity)])
						{
							
							pFEntity->v.fuser1 += 50.0;
							if(pFEntity->v.fuser1 >= 1000)
							{
								// enough played, now we sporeify this entity
								//CForwardObject->pev->iuser4 |= MASK_UPGRADE_11;
								// Give it a neat greenish glow (So marines know it's spored)
								pFEntity->v.vuser3.x = 1;
								pFEntity->v.euser1 = pEntity;
								pFEntity->v.vuser2.x = gpGlobals->time;
								pFEntity->v.rendermode = kRenderNormal;
								pFEntity->v.renderfx = kRenderFxGlowShell;
								pFEntity->v.renderamt = 0;
								pFEntity->v.rendercolor.x = 0.0;
								pFEntity->v.rendercolor.y = 30.0;
								pFEntity->v.rendercolor.z = 0.0;
								PlayerElect[ENTINDEX(pEntity)] = FALSE;
								UTIL_EndProgress(pEntity);
								EMIT_SOUND(pFEntity, CHAN_ITEM, "weapons/devourcomplete.wav", VOL_NORM, ATTN_NORM);
							}
						}
						else
						{
							PlayerElect[ENTINDEX(pEntity)] = TRUE;
							UTIL_StartProgress(pEntity, ENTINDEX(pFEntity), 1);
							//pFEntity->v.fuser1 = fTemp;
							
						}
					}
					else
					{
						if(PlayerElect[ENTINDEX(pEntity)])
						{
							PlayerElect[ENTINDEX(pEntity)] = FALSE;
							UTIL_EndProgress(pEntity);
						}
					}
				}
				else
				{
					if(PlayerElect[ENTINDEX(pEntity)])
					{
						PlayerElect[ENTINDEX(pEntity)] = FALSE;
						UTIL_EndProgress(pEntity);
					}
				}
			}
			else
			{
				if(PlayerElect[ENTINDEX(pEntity)])
				{
					PlayerElect[ENTINDEX(pEntity)] = FALSE;
					UTIL_EndProgress(pEntity);
				}
			}
			fLastSporeTime = gpGlobals->time;
		}
		RETURN_META(MRES_HANDLED);
	}
	RETURN_META(MRES_IGNORED);
}
