//this file exists so that you can paste functions that you need from util.cpp in the actual SDK
//as well as your new custom helper functions you declared in utilfunctions.h

//REMEMBER: to keep your DLL size down, remove functions you don't need from this file


#include "plugin.h"
#include <sdk_util.h>	//pre-defined function definitions saves us a lot of work
#include <cbase.h>

//decided to just fukkit and add all the headers that show up in the hlsdk util.cpp
#include <gamerules.h>
#include <saverestore.h>
#include <time.h>
#include <shake.h>
#include <decals.h>
#include <player.h>
//#include <weapons.h>

DLL_GLOBAL const Vector     g_vecZero = Vector(0,0,0);

int UTIL_DoSpore(CBaseEntity *pPlayer,CBaseEntity *pChamb,int uiResHeavy,float ufResSTime,float ufResRange,float ufResDmg,float ufResOffset)
{
	int iDmgAlready=0;
	if (pChamb->pev->vuser3.x == 1) // Building is sporified.
	{
		if (UTIL_GetDistance(pPlayer,pChamb) <= ufResRange) // Player is in range...
		{
			if (pPlayer->pev->team != pChamb->pev->team) // Different teams
			{

				if (FStrEq(STRING(pPlayer->pev->model),"models/player/heavy/heavy.mdl"))
				{
					if (uiResHeavy == 0)
					{
						pPlayer->TakeDamage(VARS(pChamb->edict()),VARS(pChamb->edict()->v.euser1),ufResDmg,1);
					}
					else if (uiResHeavy == 2)
					{
						pPlayer->TakeDamage(VARS(pChamb->edict()),VARS(pChamb->edict()->v.euser1),(ufResDmg / 2),1);
					}
				}
				else
				{
					pPlayer->TakeDamage(VARS(pChamb->edict()),VARS(pChamb->edict()->v.euser1),ufResDmg,1);
				}
				if ((gpGlobals->time - pChamb->pev->vuser2.x) >= ufResSTime)
				{
					pChamb->pev->vuser2.x = gpGlobals->time;
					edict_t *pSpore;
					pSpore=CREATE_NAMED_ENTITY(MAKE_STRING("sporegunprojectile"));
					pSpore->v.origin.x = pChamb->pev->origin.x;
					pSpore->v.origin.y = pChamb->pev->origin.y;
					pSpore->v.origin.z = pChamb->pev->origin.z + 10.0;
					MDLL_Spawn(pSpore);
					MDLL_Touch(pSpore,pPlayer->edict());
				}
				return 1;
			}
		}
	}
	return 0;
}

int UTIL_GetDistance(CBaseEntity *pEntitya,CBaseEntity *pEntityb)
{
	int iReturn = 0;
	iReturn += (int)ABSOLUTE_VALUE_EASY(pEntitya->pev->origin.x - pEntityb->pev->origin.x);
	iReturn += (int)ABSOLUTE_VALUE_EASY(pEntitya->pev->origin.y - pEntityb->pev->origin.y);
	iReturn += (int)ABSOLUTE_VALUE_EASY(pEntitya->pev->origin.z - pEntityb->pev->origin.z);
	return iReturn;
}

void UTIL_StartProgress(edict_t *pEntity, const int dest, const int mode)
{
   MESSAGE_BEGIN( MSG_ONE_UNRELIABLE, REG_USER_MSG( "Progress", -1 ), NULL, pEntity );
   WRITE_SHORT(dest);
   WRITE_BYTE(mode);
   MESSAGE_END();
}

void UTIL_EndProgress(edict_t *pEntity)
{
   MESSAGE_BEGIN( MSG_ONE_UNRELIABLE, REG_USER_MSG( "Progress", -1 ), NULL, pEntity );
   WRITE_SHORT(-1);
   WRITE_BYTE(-1);
   MESSAGE_END();
}

CBaseEntity *FindEntityForward( CBaseEntity *pMe )
{
	TraceResult tr;

	UTIL_MakeVectors(pMe->pev->v_angle);
	UTIL_TraceLine(pMe->pev->origin + pMe->pev->view_ofs,pMe->pev->origin + pMe->pev->view_ofs + gpGlobals->v_forward * 100,dont_ignore_monsters, pMe->edict(), &tr );
	if ( tr.flFraction != 1.0 && !FNullEnt( tr.pHit) )
	{
		CBaseEntity *pHit = CBaseEntity::Instance( tr.pHit );
		return pHit;
	}
	return NULL;
}
void UTIL_TraceLine( const Vector &vecStart, const Vector &vecEnd, IGNORE_MONSTERS igmon, IGNORE_GLASS ignoreGlass, edict_t *pentIgnore, TraceResult *ptr )
{
	TRACE_LINE( vecStart, vecEnd, (igmon == ignore_monsters ? TRUE : FALSE) | (ignoreGlass?0x100:0), pentIgnore, ptr );
}


void UTIL_TraceLine( const Vector &vecStart, const Vector &vecEnd, IGNORE_MONSTERS igmon, edict_t *pentIgnore, TraceResult *ptr )
{
	TRACE_LINE( vecStart, vecEnd, (igmon == ignore_monsters ? TRUE : FALSE), pentIgnore, ptr );
}
void UTIL_MakeVectors( const Vector &vecAngles )
{
	MAKE_VECTORS( vecAngles );
}

bool UTIL_CanSporify(edict_t *pent)
{
	int iesporebuild = (int)cvar_sd_rspore_build->value;

	if(FStrEq(STRING(pent->v.classname), "alienresourcetower")) {
		if(iesporebuild & 1)
			return TRUE;
	}
	else if(FStrEq(STRING(pent->v.classname), "offensechamber")) {
		if(iesporebuild & 2)
			return TRUE;
	}
	else if(FStrEq(STRING(pent->v.classname), "defensechamber")) {
		if(iesporebuild & 4)
			return TRUE;
	}
	else if(FStrEq(STRING(pent->v.classname), "movementchamber")) {
		if(iesporebuild & 8)
			return TRUE;
	}
	else if(FStrEq(STRING(pent->v.classname), "sensorychamber")) {
		if(iesporebuild & 16)
			return TRUE;
	}
	else {
		return FALSE;
	}
	return FALSE;
}

//Thx to voogru
bool UTIL_IsBuilt(edict_t *pent)
{
	if( ! (pent->v.iuser4 & (1<<2)) )
	{
		return true;
	}
	else if(FStrEq(STRING(pent->v.classname),"team_hive") && pent->v.fuser1 >= 1000)//Hives are just wierd.
	{
		pent->v.iuser4 &= ~(1<<2);
		return true;
	}
	return false;
}





//=========================================================
// UTIL_LogPrintf - Prints a logged message to console.
// Preceded by LOG: ( timestamp ) < message >
//=========================================================
void UTIL_LogPrintf( char *fmt, ... )
{
	va_list			argptr;
	static char		string[1024];
	
	va_start ( argptr, fmt );
	vsprintf ( string, fmt, argptr );
	va_end   ( argptr );

	// Print to server console
	ALERT( at_logged, "%s", string );
}

// returns a CBaseEntity pointer to a player by index.  Only returns if the player is spawned and connected
// otherwise returns NULL
// Index is 1 based
CBaseEntity	*UTIL_PlayerByIndex( int playerIndex )
{
	CBaseEntity *pPlayer = NULL;

	if ( playerIndex > 0 && playerIndex <= gpGlobals->maxClients )
	{
		edict_t *pPlayerEdict = INDEXENT( playerIndex );
		if ( pPlayerEdict && !pPlayerEdict->free )
		{
			pPlayer = CBaseEntity::Instance( pPlayerEdict );	
		}
	}
	
	return pPlayer;
}

CBaseEntity *UTIL_FindEntityByString(CBaseEntity *pStartEntity, const char *szKeyword, const char *szValue)
{
	edict_t	*pentEntity;

	if (pStartEntity)
		pentEntity = pStartEntity->edict();
	else
		pentEntity = NULL;

	pentEntity = FIND_ENTITY_BY_STRING(pentEntity, szKeyword, szValue);

	if (!FNullEnt(pentEntity))
		return CBaseEntity::Instance(pentEntity);
	return NULL;
}
CBaseEntity *UTIL_FindEntityInSphere( CBaseEntity *pStartEntity, const Vector &vecCenter, float flRadius )
{
	edict_t	*pentEntity;

	if (pStartEntity)
		pentEntity = pStartEntity->edict();
	else
		pentEntity = NULL;

	pentEntity = FIND_ENTITY_IN_SPHERE( pentEntity, vecCenter, flRadius);

	if (!FNullEnt(pentEntity))
		return CBaseEntity::Instance(pentEntity);
	return NULL;
}

unsigned short FixedUnsigned16( float value, float scale )
{
	int output;

	output = (int)(value * scale);
	if ( output < 0 )
		output = 0;
	if ( output > 0xFFFF )
		output = 0xFFFF;

	return (unsigned short)output;
}

short FixedSigned16( float value, float scale )
{
	int output;

	output = (int)(value * scale);

	if ( output > 32767 )
		output = 32767;

	if ( output < -32768 )
		output = -32768;

	return (short)output;
}
CBaseEntity *UTIL_FindEntityByClassname( CBaseEntity *pStartEntity, const char *szName )
{
  return UTIL_FindEntityByString( pStartEntity, "classname", szName );
}
void EMIT_SOUND_DYN(edict_t *entity, int channel, const char *sample, float volume, float attenuation, int flags, int pitch)
{
	EMIT_SOUND_DYN2(entity, channel, sample, volume, attenuation, flags, pitch);
}
